module VerifyExamples.Tracery.RunTo0 exposing (..)

-- This file got generated by [elm-verify-examples](https://github.com/stoeffel/elm-verify-examples).
-- Please don't modify this file by hand!

import Test
import Expect

import Tracery exposing (..)
import Result.Extra
import Random
import Json.Decode



generateTo : List String -> ({variable:String} -> String)-> Int -> String -> String
generateTo list fun seed json =
    json
        |> Tracery.fromJson
        |> Result.Extra.unpack
            Json.Decode.errorToString
            (\grammar ->
                Random.step (Tracery.runTo list grammar) (Random.initialSeed seed)
                    |> Tuple.first
                    |> toString fun
            )



spec0 : Test.Test
spec0 =
    Test.test "#runTo: \n\n    \"\"\"\n    { \"origin\": [\"A #color# #animal#\"]\n    , \"color\": [\"black\",\"white\",\"gray\"]\n    , \"animal\":\n      [ \"cat, looking at a #color# #animal#\"\n      , \"bird.\"\n      ]\n    }\n    \"\"\"\n    |> generateTo [\"animal\"] (\\{variable} -> \"dog.\") 42\n    --> \"A black dog.\"" <|
        \() ->
            Expect.equal
                (
                """
                { "origin": ["A #color# #animal#"]
                , "color": ["black","white","gray"]
                , "animal":
                  [ "cat, looking at a #color# #animal#"
                  , "bird."
                  ]
                }
                """
                |> generateTo ["animal"] (\{variable} -> "dog.") 42
                )
                (
                "A black dog."
                )